using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
//using NationalInstruments.NI4882;   // GP-IBvO~OEC^tF[X
using GPIBDummyDriver;

/*********************************************************

   Iwatsu VOAC7412 [U[Rg[

*********************************************************/

namespace Iwatsu
{
    public partial class VOAC7412 : UserControl
    {
    
        // dON/OFF̗񋓌^萔
        public enum VOACPowers
        {
            PowerOFF,
            PowerON
        }

        // t@NV̗񋓌^萔
        public enum VOACFunctions : int
        {
            DCV = 0,
            ACV = 1,
            Ohm = 2,
            DCA = 3,
            ACA = 4,
            TC = 5,
            Frequency = 6,
            LoOhm = 7
        }

        // 背W̗񋓌^萔
        public enum VOACRanges : int
        {
            AUTO = 0,
            V40mV_R40 = 1,
            V400mV_R400_C400uA = 2,
            V4V_R4k_C4mA = 3,
            V40V_R40k_C40mA = 4,
            V400V_R400k_C400mA = 5,
            V750V_R4000k_C4A = 6,
            R400M_C10A = 7,
            R400M = 8
        }

        // vpeB̒l
        private byte gpibAddress = 1;
        private VOACPowers voacPower  = VOACPowers.PowerOFF;
        private VOACFunctions voacFunction = VOACFunctions.DCV;
        private VOACRanges voacRange = VOACRanges.AUTO;

        // privateϐ
        private Device device;      // GP-IB@
        private bool pp = false;    // voacPoweȓȌ

        // RXgN^
        public VOAC7412()
        {
            InitializeComponent();

            // [U[Rg[DisposedCxgnh̒ǉ
            this.Disposed += new System.EventHandler(this.VOAC7412_Disposed);

            // t@NVݒ肷ComboBoxItem̒ǉ
            functionComboBox.Items.AddRange(new string[] { "DCV", "ACV", "", "DCA", "ACA", "", "Hz", "LO-" });
        }

        // GpibAddressvpeB
        [DescriptionAttribute("}`[^GP-IBAhXw肵܂B"), CategoryAttribute("}`[^"), DefaultValueAttribute(1)]
        public byte GpibAddress
        {
            get
            {
                return gpibAddress;
            }
            set
            {
                gpibAddress = (byte)value;

                // GPIBAhXݒ肷NumericUpDownRg[̐ݒ
                gPIBAddressNumericUpDown.Value = gpibAddress;
            }
        }

        // PowervpeB
        [DescriptionAttribute("}`[^̓dON/OFFw肵܂B"), CategoryAttribute("}`[^"), DefaultValueAttribute(VOACPowers.PowerOFF)]
        public VOACPowers Power 
        {
            get
            {
                return voacPower;
            }
            set
            {
                voacPower = value;

                // dON/OFFݒ肷郁\bȟĂяo
                SetPower();
            }
        }

        // MeasureFunctionvpeB
        [DescriptionAttribute("}`[^̑t@NVw肵܂B"), CategoryAttribute("}`[^"), DefaultValueAttribute(VOACFunctions.DCV)]
        public VOACFunctions MeasureFunction 
        {
            get
            {
                return voacFunction;
            }
            set
            {
                voacFunction = value;

                // t@NVݒ肷ComboBoxRg[̐ݒ
                functionComboBox.SelectedIndex = (int)voacFunction;

                // t@NVݒ肷郁\bȟĂяo
                SetFunction();
            }
        }

        // MeasureRangevpeB
        [DescriptionAttribute("}`[^̑背Ww肵܂B"), CategoryAttribute("}`[^"), DefaultValueAttribute(VOACRanges.AUTO)]
        public VOACRanges MeasureRange
        {
            get
            {
                return voacRange;
            }
            set
            {
                voacRange = value;

                // 背Wݒ肷郁\bȟĂяo
                SetRange();
            }
        }

        // Measure\bh
        public string Measure()
        {
            byte sPoll;             // |[Op
            string buffer = "";

            if (voacPower == VOACPowers.PowerON)
            {
                // dON̏

                // |[Oɂ@킩̑IM̌o
                do
                {
                    sPoll = (byte)device.SerialPoll();
                } while ((sPoll & 16) == 16);

                // GP-IB@킩̒l̓ǂݍ
                try
                {
                    buffer = device.ReadString();
                    
                    // l̕\
                    dataLabel.Text = buffer.Substring(4);

                    // l̒Pʂ̕\
                    switch (buffer.Substring(0, 2))
                    {
                        case "DV":
                        case "AV":
                            unitLabel.Text = "V";
                            break;
                        case "R ":
                            unitLabel.Text = "";
                            break;
                        case "DA":
                        case "AA":
                            unitLabel.Text = "A";
                            break;
                        case "TC":
                            unitLabel.Text = "C";
                            break;
                        case "F ":
                            unitLabel.Text = "Hz";
                            break;
                    }
                }
                catch (Exception)
                {
                    buffer = "MG[";
                    dataLabel.Text = buffer;
                }
            }
            else
            {
                // dOFF̏
                buffer = "";
                dataLabel.Text = "OFF";
            }

            // ߂l̐ݒ
            return buffer;
        }

        //@[U[Rg[LoadCxgnh
        private void VOAC7412_Load(object sender, EventArgs e)
        {
            // [U[Rg[̕\̏ݒ
            dataLabel.Text = "OFF";
            unitLabel.Text = "";

            // GP-IBAhXINumericUpDownRg[̐ݒ
            gPIBAddressNumericUpDown.Value = gpibAddress;

            // t@NVIComboBoxRg[̐ݒ
            functionComboBox.SelectedIndex = (int)voacFunction;
        }

        // [U[Rg[DisposedCxgnh
        private void VOAC7412_Disposed(object sender, EventArgs e)
        {
            // x[XNXDispose
            base.Dispose();

            try
            {
                // IWATSU VOAC7412̐R}h̑o
                device.Write("PA0");            // AVG OFF

                // GP-IB@[Jɐݒ
                device.GoToLocal();

                // GP-IB@̔j
                device.Dispose();
            }
            catch (Exception)
            {
            }
        }

        // GP-IBAhXݒ肷NumericUpDownRg[ValueChangedCxgnh
        private void gPIBAddressNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            gpibAddress = (byte)gPIBAddressNumericUpDown.Value;
        }

        // dON/OFFݒ肷LabelRg[ClickCxgnh
        private void powerSwitchLabel_Click(object sender, EventArgs e)
        {

            // dON/OFF̐؂ւݒ
            if (voacPower == VOACPowers.PowerOFF)
            {
                voacPower = VOACPowers.PowerON;
            }
            else
            {
                voacPower = VOACPowers.PowerOFF;
            }

            // dON/OFFɊւ郁\bȟďo
            SetPower();
        }

        // t@NVݒ肷ComboBoxRg[
        // SelectedIndexChangedCxgnh
        private void functionComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            // t@NV̕ύX
            switch ((string)functionComboBox.SelectedItem)
            {
                case "DCV":
                    voacFunction = VOACFunctions.DCV;
                    break;
                case "ACV":
                    voacFunction = VOACFunctions.ACV;
                    break;
                case "":
                    voacFunction = VOACFunctions.Ohm;
                    break;
                case "DCA":
                    voacFunction = VOACFunctions.DCA;
                    break;
                case "ACA":
                    voacFunction = VOACFunctions.ACA;
                    break;
                case "":
                    voacFunction = VOACFunctions.TC;
                    break;
                case "Hz":
                    voacFunction = VOACFunctions.Frequency;
                    break;
                case "LO-":
                    voacFunction = VOACFunctions.LoOhm;
                    break;
            }

            // t@NVݒ肷郁\bȟĂяo
            SetFunction();
        }

        // 背Wݒ肷ButtonRg[ClickCxgnh
        private void rangeButton_Click(object sender, EventArgs e)
        {
            // 背W̕ύX
            if (((Button)sender).Name == rangeDownButton.Name)
            {
                voacRange = (VOACRanges)(voacRange-1);
                if (voacRange <= (VOACRanges)0)
                {
                    voacRange = (VOACRanges)8;
                }
            }
            else if (((Button)sender).Name == rangeUpButton.Name)
            { 
                voacRange = (VOACRanges)(voacRange+1);
                if (voacRange == (VOACRanges)9)
                {
                    voacRange = (VOACRanges)1;
                }
            }
            else
            {
                voacRange = (VOACRanges)0;
            }

            // 背Wݒ肷郁\bȟĂяo
            SetRange();
        }

        // dON/OFFɊւ鏈
        private void SetPower()
        {
            if (voacPower == VOACPowers.PowerON)
            {
                // ON̐ݒ

                // GP-IB@̏
                try
                {
                    device = new Device(0, gpibAddress);
                }
                catch (Exception)
                {
                    dataLabel.Text = "G[";
                }

                // foCX̃NA
                device.Clear();

                // IWATSU VOAC7412̐R}h̑o
                try
                {
                    device.Write("X2 AE0 AA5 PA1");      
                }
                catch (Exception)
                {
                    dataLabel.Text = "MG[";
                }

                // tH[̕\̐ݒ
                dataLabel.Text = "ON";

                // d{^̕\̐ݒ
                powerSwitchLabel.BackColor = Color.Red;

                // Poweȑԕێ
                pp = true;
            }
            else
            {
                // OFF̐ݒ

                // ONOFF̊mF
                if (pp)
                {
                    device.Write("PA0");            // AVG OFF
                    
                    // GP-IB@[Jɐݒ
                    device.GoToLocal();

                    // GP-IB@̔j
                    device.Dispose();

                    // tH[̕\̐ݒ
                    dataLabel.Text = "OFF";
                    unitLabel.Text = "";

                    // d{^̕\̐ݒ
                    powerSwitchLabel.BackColor = Color.White;

                    // Poweȑԕێ
                    pp = false;
                }
            }
        }

        // t@NVɊւ鏈
        private void SetFunction()
        {
            string  cmd = "F0";

            // t@NVݒR}h̑I
            switch (voacFunction)
            {
                case VOACFunctions.DCV:
                    cmd = "F0";
                    break;
                case VOACFunctions.ACV:
                    cmd = "F1";
                    break;
                case VOACFunctions.Ohm:
                    cmd = "F2";
                    break;
                case VOACFunctions.DCA:
                    cmd = "F3";
                    break;
                case VOACFunctions.ACA:
                    cmd = "F4";
                    break;
                case VOACFunctions.TC:
                    cmd = "F5";
                    break;
                case VOACFunctions.Frequency:
                    cmd = "F7";
                    break;
                case VOACFunctions.LoOhm:
                    cmd = "F10";
                    break;
            }
            
            if (voacPower == VOACPowers.PowerON)
            {
                try
                {
                    // IWATSU VOAC7412̐R}h̑o
                    device.Write(cmd);      
                }
                catch (Exception)
                {
                    dataLabel.Text = "MG[";
                }
            }
        }    

        // 背WɊւ鏈
        private void SetRange()
        {

            // I[gW\̐ݒ
            if (voacRange == VOACRanges.AUTO)
            {
                rangeAutoLabel.BackColor = Color.Red;
            }
            else
            {
                rangeAutoLabel.BackColor = Color.White;
            }

            if (voacPower == VOACPowers.PowerON)
            {
                try
                {
                    // IWATSU VOAC7412̐R}h̑o
                    device.Write("R" + (int)voacRange);      
                }
                catch (Exception)
                {
                    dataLabel.Text = "MG[";
                }
            }
        }    
    }
}
