using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
//using NationalInstruments.NI4882;   // GP-IBvO~OEC^tF[X
using GPIBDummyDriver;

/*********************************************************

   Agilent E3631A [U[Rg[

*********************************************************/

namespace Agilent
{
    public partial class E3631A : UserControl
    {
        // dON/OFF̗񋓌^萔
        public enum E3631APowers
        {
            PowerOFF,
            PowerON
        }

        // o͒[q̗񋓌^萔
        public enum E3631AOutputTerminals
        {
            P6V,
            P25V,
            N25V,
        }

        // o͂ON/OFF̗񋓌^萔
        public enum E3631AOutputs
        {
            OutputOFF,
            OutputON
        }

        // vpeB̒l
        private byte gpibAddress = 5;
        private E3631APowers e3631APower = E3631APowers.PowerOFF;
        private E3631AOutputTerminals e3631ATerminal = E3631AOutputTerminals.P6V;
        private E3631AOutputs E3631AOutput = E3631AOutputs.OutputOFF;
        private double e3631AVolt = 0.0;
        private double e3631ACurrent = 0.0;

        // o͂̍ői
        const double p6V_Volt_Limit = 6.0;      // +6VA5A
        const double p6V_Current_Limit = 5.0;
        const double p25V_Volt_Limit = 25.0;    // +25VA1A
        const double p25V_Current_Limit = 1.0;
        const double n25V_Volt_Limit = -25.0;   // -25VA1A
        const double n25V_Current_Limit = 1.0;

        // privateϐ
        private Device device;      // GP-IB@
        private bool eventEnabled;  // Cxgnh̎s/s
        private bool pp = false;    // e3631APoweȓȌ
        
        // RXgN^
        public E3631A()
        {
            InitializeComponent();
            
            this.Disposed += new System.EventHandler(this.E3631A_Disposed);
        }
        
        // GpibAddressvpeB
        [DescriptionAttribute("vO}udGP-IBAhXw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(5)]
        public byte GpibAddress
        {
            get
            {
                return gpibAddress;
            }
            set
            {
                gpibAddress = (byte)value;

                // GPIBAhXݒ肷NumericUpDownRg[̐ݒ
                gPIBAddressNumericUpDown.Value = gpibAddress;
            }
        }

        // PowervpeB
        [DescriptionAttribute("vO}ud̓dON/OFFw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(E3631APowers.PowerOFF)]
        public E3631APowers Power
        {
            get
            {
                return e3631APower;
            }
            set
            {
                e3631APower = value;

                // dON/OFFݒ肷郁\bȟĂяo
                SetPower();
            }
        }

        // TerminalvpeB
        [DescriptionAttribute("vO}ud̏o͒[qw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(E3631AOutputTerminals.P6V)]
        public E3631AOutputTerminals Terminal
        {
            get
            {
                return e3631ATerminal;
            }
            set
            {
                e3631ATerminal = value;

                // o͒[qݒ肷郁\bȟĂяo
                SendOutputTerminal();
            }
        }

        // OutputvpeB
        [DescriptionAttribute("vO}ud̏o͂ON/OFFw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(E3631AOutputs.OutputOFF)]
        public E3631AOutputs Output
        {
            get
            {
                return E3631AOutput;
            }
            set
            {
                E3631AOutput = value;

                // o͂ON/OFFݒ肷郁\bȟĂяo
                SetOutput();
            }
        }

        // VoltvpeB
        [DescriptionAttribute("vO}ud̏o͓dw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(0.0)]
        public double Volt
        {
            get
            {
                return e3631AVolt;
            }
            set
            {
                e3631AVolt = value;

                // dlݒ肷郁\bȟĂяo
                SetVolt();
            }
        }

        // CurrentvpeB
        [DescriptionAttribute("vO}ud̏o͓dw肵܂B"), CategoryAttribute("vO}ud"), DefaultValueAttribute(0.0)]
        public double Current
        {
            get
            {
                return e3631ACurrent;
            }
            set
            {
                e3631ACurrent = value;

                // dlݒ肷郁\bȟĂяo
                SetCurrent();
            }
        }

        //@[U[Rg[LoadCxgnh
        private void E3631A_Load(object sender, EventArgs e)
        {

            // GP-IBAhXINumericUpDownRg[̐ݒ
            gPIBAddressNumericUpDown.Value = gpibAddress;

            // dlCdlݒ肷NumericUpDownRg[̃Cxgnhs
            eventEnabled = true;

            // dON/OFFݒ肷郁\bȟĂяo
            SetPower();
        }

        // [U[Rg[DisposedCxgnh
        private void E3631A_Disposed(object sender, EventArgs e)
        {
            //@x[XNXDispose
            base.Dispose();

            try
            {
                // Agilent E3631A̐R}h̑o
                device.Write("OUTP OFF");           // oOFF̑M
                
                // GP-IB@[Jɐݒ
                device.GoToLocal();

                // GP-IB@̔j
                device.Dispose();
            }
            catch (Exception)
            {
            }
        }

        // GP-IBAhXݒ肷NumericUpDownRg[ValueChangedCxgnh
        private void gPIBAddressNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            gpibAddress = (byte)gPIBAddressNumericUpDown.Value;
        }

        // dON/OFFݒ肷LabelRg[ClickCxgnh
        private void powerSwitchLabel_Click(object sender, EventArgs e)
        {
            // dON/OFF̐؂ւݒ
            if (e3631APower == E3631APowers.PowerOFF)
            {
                e3631APower = E3631APowers.PowerON;
            }
            else
            {
                e3631APower = E3631APowers.PowerOFF;
            }

            // dON/OFFɊւ郁\bȟďo
            SetPower();
        }

        // o͒[qIRadioButtonRg[CheckedChangedCxgnh
        private void terminalRadioButton_CheckedChanged(object sender, EventArgs e)
        {
            // Io͒[qݒ
            if (((RadioButton)sender).Name == terminalP6VRadioButton.Name)
            {
                e3631ATerminal = E3631AOutputTerminals.P6V;
            }
            else if (((RadioButton)sender).Name == terminalP25VRadioButton.Name)
            {
                e3631ATerminal = E3631AOutputTerminals.P25V;
            }
            else
            {
                e3631ATerminal = E3631AOutputTerminals.N25V;
            }

            // o͒[qύXƂɂ͓dlѓdl
            e3631AVolt = 0.0;
            e3631ACurrent = 0.0;

            // o͒[q̏郁\bȟďo
            SendOutputTerminal();
        }

        // o͂ON/OFFݒ肷LabelRg[ClickCxgnh
        private void outputSwitchLabel_Click(object sender, EventArgs e)
        {
            // dON/OFF̃`FbN
            if (e3631APower == E3631APowers.PowerON)
            {
                // o͂ON/OFF̐؂ւݒ
                if (E3631AOutput == E3631AOutputs.OutputOFF)
                {
                    E3631AOutput = E3631AOutputs.OutputON;
                }
                else
                {
                    E3631AOutput = E3631AOutputs.OutputOFF;
                }
            }
            else
            {
                // dOFF̏ꍇ́Ao͂OFFɂ
                E3631AOutput = E3631AOutputs.OutputOFF;
            }

            // o͂ON/OFFɊւ郁\bȟĂяo
            SetOutput();
        }

        // dlݒ肷NumericUpDownRg[ValueChangedCxgnh
        private void voltNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            int i;
            int p = 3;

            // Cxgnh͎s\
            if (eventEnabled)
            {
                // NumericUpDownRg[̒l̓Ǎ
                i = (int)(voltNumericUpDown1.Value * 1000 + voltNumericUpDown2.Value * 100 + voltNumericUpDown3.Value * 10 + voltNumericUpDown4.Value);

                // o͒[qʂ̏_ȉƕ̐ݒ
                switch (e3631ATerminal)
                {
                    case E3631AOutputTerminals.P6V:
                        p = 3;
                        break;
                    case E3631AOutputTerminals.P25V:
                        p = 2;
                        break;
                    case E3631AOutputTerminals.N25V:
                        i *= -1;
                        p = 2;
                        break;
                }

                // ݒd̑
                e3631AVolt = i / Math.Pow(10, p);

                // dlݒ肷郁\bȟĂяo
                SetVolt();
            }
        }

        // dlݒ肷NumericUpDownRg[ValueChangedCxgnh
        private void currentNumericUpDown_ValueChanged(object sender, EventArgs e)
        {
            int i;
            int p;

            // Cxgnh͎s\
            if (eventEnabled)
            {
                // NumericUpDownRg[̒l̓Ǎ
                i = (int)(currentNumericUpDown1.Value * 1000 + currentNumericUpDown2.Value * 100 + currentNumericUpDown3.Value * 10 + currentNumericUpDown4.Value);

                // _ȉ
                p = 3;

                // ݒd̑
                e3631ACurrent = i / Math.Pow(10,p);

                // dlݒ肷郁\bȟĂяo
                SetCurrent();
            }
        }
        
        // dON/OFFɊւ鏈
        private void SetPower()
        {
            if (e3631APower == E3631APowers.PowerON)
            {
                // ON̐ݒ

                // GP-IB@̏
                try
                {
                    device = new Device(0, gpibAddress);
                }
                catch (Exception)
                {
                
                }

                // foCX̃NA
                device.Clear();

                // d{^̕\̐ݒ
                powerSwitchLabel.BackColor = Color.Red;

                // o͒[q̏郁\bȟďo
                SendOutputTerminal();

                // Poweȑԕێ
                pp = true;
            }
            else
            {
                // OFF̐ݒ

                // ONOFF̊mF
                if (pp)
                {
                    // GP-IB@[Jɐݒ
                    device.GoToLocal();

                    // GP-IB@̔j
                    device.Dispose();

                    // d{^̕\̐ݒ
                    powerSwitchLabel.BackColor = Color.White;
                }
            }
        }

        // o͒[qʂ̓dɊւ鏈
        private void SendOutputTerminal()
        {
            string ot="";
            
            // dON/OFF̃`FbN
            if (e3631APower == E3631APowers.PowerON)
            {
                // Agilent E3631A̐R}h̑o
                switch (e3631ATerminal)
                {
                    case E3631AOutputTerminals.P6V:
                        ot = "INST P6V";              // {Uu[q̑I
                        break;
                    case E3631AOutputTerminals.P25V:
                        ot = "INST P25V";             // {QTu[q̑I
                        break;
                    case E3631AOutputTerminals.N25V:
                        ot = "INST N25V";             // |QTu[q̑I
                        break;
                }

                try
                {
                    device.Write(ot);    
                }
                catch (Exception)
                {
                }

                // o͂ON/OFFɊւ郁\bȟĂяo
                SetOutput();
            }
        }

        // o͂ON/OFFɊւ鏈
        private void SetOutput()
        {

            // dON/OFF̃`FbN
            if (e3631APower == E3631APowers.PowerON)
            {
                if (E3631AOutput == E3631AOutputs.OutputON)
                {
                    // oON̐ݒ
                    try
                    {
                        // Agilent E3631A̐R}h̑o
                        device.Write("OUTP ON");        // oON̑M
                    }
                    catch (Exception)
                    {
                    }

                    // o̓{^̕\̐ݒ
                    outputSwitchLabel.BackColor = Color.Red;
                    
                    // dlݒ肷郁\bȟĂяo
                    SetVolt();

                    // dlݒ肷郁\bȟĂяo
                    SetCurrent();
                }
                else
                {
                    // oOFFւ̐ݒ
                    try
                    {
                        // Agilent E3631A̐R}h̑o
                        device.Write("OUTP OFF");       // oOFF̑M
                    }
                    catch (Exception)
                    {
                    }

                    // o̓{^̕\̐ݒ
                    outputSwitchLabel.BackColor = Color.White;
                }
            }
        }

        // dl̐ݒ
        private void SetVolt()
        {
            // Io͒[qʂ̍őiɑ΂鏈
            switch (e3631ATerminal)
            {
                case E3631AOutputTerminals.P6V:
                    if (e3631AVolt < 0)
                    {
                        e3631AVolt = 0;
                    }
                    if (e3631AVolt > p6V_Volt_Limit)
                    {
                        e3631AVolt = p6V_Volt_Limit;
                    }
                    break;

                case E3631AOutputTerminals.P25V:
                    if (e3631AVolt < 0)
                    {
                        e3631AVolt = 0;
                    }
                    if (e3631AVolt > p25V_Volt_Limit)
                    {
                        e3631AVolt = p25V_Volt_Limit;
                    }
                    break;

                case E3631AOutputTerminals.N25V:
                    if (e3631AVolt > 0)
                    {
                        e3631AVolt = 0;
                    }
                    if (e3631AVolt < n25V_Volt_Limit)
                    {
                        e3631AVolt = n25V_Volt_Limit;
                    }
                    break;
            }

            // Io͒[qʂ̓d\̏
            switch (e3631ATerminal)
            {
                case E3631AOutputTerminals.P6V:
                    voltLabel.Text = e3631AVolt.ToString("0.000");
                    break;
                case E3631AOutputTerminals.P25V:
                    voltLabel.Text = e3631AVolt.ToString("00.00");
                    break;
                case E3631AOutputTerminals.N25V:
                    voltLabel.Text = e3631AVolt.ToString("00.00");
                    break;
            }
            
            // dlݒ肷NumericUpDownRg[ValuevpeB̍Đݒ
            int i;
            int p = 3;

            switch (e3631ATerminal)
            {
                case E3631AOutputTerminals.P6V:
                    p = 3;
                    break;
                case E3631AOutputTerminals.P25V:
                    p = 2;
                    break;
                case E3631AOutputTerminals.N25V:
                    p = 2;
                    break;
            }
            i = Math.Abs((int)(e3631AVolt*Math.Pow(10,p)));

            eventEnabled = false;    //@Đݒ莞ɃCxgnhsȂ
            voltNumericUpDown1.Value = decimal.Parse(i.ToString("0000").Substring(0, 1));
            voltNumericUpDown2.Value = decimal.Parse(i.ToString("0000").Substring(1, 1));
            voltNumericUpDown3.Value = decimal.Parse(i.ToString("0000").Substring(2, 1));
            voltNumericUpDown4.Value = decimal.Parse(i.ToString("0000").Substring(3, 1));
            eventEnabled = true;

            // dON/OFFƏoON/OFF̃`FbN
            if (e3631APower == E3631APowers.PowerON && E3631AOutput == E3631AOutputs.OutputON)
            {
                try
                {
                    // Agilent E3631Ȁo͓dݒ̑M
                    device.Write("VOLT " + e3631AVolt.ToString("0.0000"));
                }
                catch (Exception)
                {
                }
            }
        }

        // dl̐ݒ
        private void SetCurrent()
        {
            // Io͒[qʂɍőiɑ΂鏈
            if (e3631ACurrent < 0 )
            {
                e3631ACurrent = 0;
            }
            switch (e3631ATerminal)
            {
                case E3631AOutputTerminals.P6V:
                    if (e3631ACurrent > p6V_Current_Limit)
                    {
                        e3631ACurrent = p6V_Current_Limit;
                    }
                    break;

                case E3631AOutputTerminals.P25V:
                    if (e3631ACurrent > p25V_Current_Limit)
                    {
                        e3631ACurrent = p25V_Current_Limit;
                    }
                    break;

                case E3631AOutputTerminals.N25V:
                    if (e3631ACurrent > n25V_Current_Limit)
                    {
                        e3631ACurrent = n25V_Current_Limit;
                    }
                    break;
            }

            // d\̏
            currentLabel.Text = e3631ACurrent.ToString("0.000");

            // dlݒ肷NumericUpDownRg[ValuevpeB̍Đݒ
            int i;
            int p;

            p = 3;
            i = (int)(e3631ACurrent*Math.Pow(10,p));

            eventEnabled = false;    // Đݒ莞ɃCxgnhsȂ
            currentNumericUpDown1.Value = decimal.Parse(i.ToString("0000").Substring(0, 1));
            currentNumericUpDown2.Value = decimal.Parse(i.ToString("0000").Substring(1, 1));
            currentNumericUpDown3.Value = decimal.Parse(i.ToString("0000").Substring(2, 1));
            currentNumericUpDown4.Value = decimal.Parse(i.ToString("0000").Substring(3, 1));
            eventEnabled = true;

            // dON/OFFƏoON/OFF̃`FbN
            if (e3631APower == E3631APowers.PowerON && E3631AOutput == E3631AOutputs.OutputON)
            {
                try
                {
                    // Agilent E3631Ȁo͓dݒ̑M
                    device.Write("CURR " + e3631ACurrent.ToString("0.0000"));
                }
                catch (Exception) 
                {
                }
            }
        }
    }
}
