using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/*********************************************************

   _CI[h̓d-dtH[

********************************************************/

namespace MeasurementSystem
{
    public partial class MeasurementSystemForm : Form
    {
        public MeasurementSystemForm()
        {
            InitializeComponent();
        }

        // tH[LoadCxgnh
        private void MeasurementSystemForm_Load(object sender, EventArgs e)
        {
            // DataGridViewRg[̏ݒ
            measurementDataGridView.ColumnCount = 4;
            measurementDataGridView.Columns[0].Name = "No.";
            measurementDataGridView.Columns[1].Name = "ݒd(V)";
            measurementDataGridView.Columns[2].Name = "d(V)";
            measurementDataGridView.Columns[3].Name = "d(A)";
            measurementDataGridView.Columns[0].Width = 40;
            measurementDataGridView.Columns[0].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            measurementDataGridView.Columns[1].Width = 100;
            measurementDataGridView.Columns[1].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            measurementDataGridView.Columns[2].Width = 100;
            measurementDataGridView.Columns[2].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            measurementDataGridView.Columns[3].Width = 100;
            measurementDataGridView.Columns[3].DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight;
            measurementDataGridView.RowHeadersVisible = false;

            // dpRg[̏ݒ
            voltVoaC7412.GpibAddress = 1;
            voltVoaC7412.MeasureFunction = Iwatsu.VOAC7412.VOACFunctions.DCV;
            voltVoaC7412.MeasureRange = Iwatsu.VOAC7412.VOACRanges.AUTO;

            // dpRg[̏ݒ
            currentVoaC7412.GpibAddress = 2;
            currentVoaC7412.MeasureFunction = Iwatsu.VOAC7412.VOACFunctions.DCA;
            currentVoaC7412.MeasureRange = Iwatsu.VOAC7412.VOACRanges.AUTO;

            // dpRg[̏ݒ
            voltSourceE3631A.GpibAddress = 5;
            voltSourceE3631A.Output = Agilent.E3631A.E3631AOutputs.OutputOFF;
            voltSourceE3631A.Terminal = Agilent.E3631A.E3631AOutputTerminals.P6V;
            voltSourceE3631A.Volt = 0.0;
            voltSourceE3631A.Current = 0.0;
        }

        // JnButtonRg[̃Cxgnh
        private void measureButton_Click(object sender, EventArgs e)
        {
            int n;          // _
            double volt;    // ݒdl
            string mv;      // dl
            string mc;      // dl
            Object[] rd;    // DataGridViewւ̍s̒ǉp

            // _̏
            n = 0;

            // DataGridView̃NA
            measurementDataGridView.Rows.Clear();

            // v@̎nݒ
            voltVoaC7412.Power = Iwatsu.VOAC7412.VOACPowers.PowerON;
            currentVoaC7412.Power = Iwatsu.VOAC7412.VOACPowers.PowerON;
            voltSourceE3631A.Power = Agilent.E3631A.E3631APowers.PowerON;
            voltSourceE3631A.Current = double.Parse(currentLimitTextBox.Text);
            voltSourceE3631A.Output = Agilent.E3631A.E3631AOutputs.OutputON;
            
            // ṽ[v
            do
            {
                // ݒďvZ
                volt = double.Parse(voltStartTextBox.Text) + double.Parse(voltStepTextBox.Text) * n;

                // dd̓dlݒ
                voltSourceE3631A.Volt = volt;

                // Wait
                System.Threading.Thread.Sleep(1000);

                // dl̑
                mv = voltVoaC7412.Measure();
                // dl̑
                mc = currentVoaC7412.Measure();

                // DataGridViewւ̒ǉ
                n += 1;
                rd = new Object[] {n, 
                                   volt,
                                   double.Parse(mv.Substring(4, 10)),
                                   double.Parse(mc.Substring(4, 10))};
                measurementDataGridView.Rows.Add(rd);

                this.Refresh();
            }
            while (volt < double.Parse(voltStopTextBox.Text));

            // v@̏Iݒ
            voltSourceE3631A.Output = Agilent.E3631A.E3631AOutputs.OutputOFF;
            voltSourceE3631A.Volt = 0.0;
            voltSourceE3631A.Current = 0.0;
            voltVoaC7412.Power = Iwatsu.VOAC7412.VOACPowers.PowerOFF;
            currentVoaC7412.Power = Iwatsu.VOAC7412.VOACPowers.PowerOFF;
            voltSourceE3631A.Power = Agilent.E3631A.E3631APowers.PowerOFF;
        }
    }
}