﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using NationalInstruments.NI4882;   // GP-IBプログラミング・インタフェース

/// <summary>
/// VOAC7412Temp の概要の説明です
/// </summary>
public class VOAC7412Temp
{
	public VOAC7412Temp()
	{
		//
		// TODO: コンストラクタ ロジックをここに追加します
		//
	}

    /// <summary>
    /// VOAC7412で温度を計測します
    /// </summary>
    /// <param name="addr">計測機器のGP-IBアドレス</param>
    /// <returns>測定した温度</returns>
    public string GetTemp(byte addr)
    {
        Device device;      // GP-IB機器を扱うインスタンス変数
        string buffer = ""; // 読み込みデータ保存用
        byte sPoll;         // ポーリング用

        try
        {
            // GP-IB機器のインスタンスの生成
            device = new Device(0, addr);

            // デバイスのクリア
            device.Clear();

            // IWATSU VOAC7412の制御コマンドの送出
            device.Write("X2 AE0");         // フリーランモード,SRQなし
            device.Write("F5 S1");          // 温度,サンプルレートMID
            
            // ポーリングによる機器からの測定終了信号の検出
            do
            {
                sPoll = (byte)device.SerialPoll();
            } while ((sPoll & 16) == 16);

            // GP-IB機器からの値の読み込み
            buffer = device.ReadString();

            // GP-IB機器をローカルに設定
            device.GoToLocal();

            // GP-IB機器の破棄
            device.Dispose();

            // 戻り値
            return (double.Parse(buffer.Substring(5))).ToString("#.0") + "℃";
        }
        catch (Exception)
        {
            return "計測エラー";
        }
    }

}
