using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/*****************************************************************
    
   ̃vO͂R̃f[^Fŕ\vOł
   f[^̃R[hǉ̂ł
    
******************************************************************/

namespace ColorMapViewer
{
    public partial class ColorMapViewerForm : Form
    {
        // C^Cgi萔錾j
        const string mainTitle = "ColorMapViewer";

        // pxAʓxAx̐ݒ͈͕ۑp
        private int angleStart = 0;         // px̊Jnl
        private int angleRange = 360;       // px͈̔
        private double sharpStart = 1.0;    // ʓx̊Jnl
        private double sharpRange = 0.0;    // ʓx͈̔
        private double volStart = 1.0;      // x̊Jnl
        private double volRange = 0.0;      // x͈̔

        // Rf[^ۑp
        private int[,] data3D = new int[128, 128];
        
        public ColorMapViewerForm()
        {
            InitializeComponent();
        }

        // t@CJButtonClickCxgnh
        private void fileOpenButton_Click(object sender, EventArgs e)
        {
            string dataFileName;            //@t@C
            string dataFileExtension;       //@t@C̊gq

            // t@CJOpenFileDialog̐ݒ
            dataOpenFileDialog.Filter = "eLXgt@C (*.txt)|*.txt|oCi[t@C (*.bin)|*.bin|SẴt@C (*.*)|*.*";
            dataOpenFileDialog.FilterIndex = 1;

            // _CAO{bNXOKꂽ珈
            if (dataOpenFileDialog.ShowDialog() == DialogResult.OK)
            {
                // }EX|C^vɂ
                Cursor.Current = Cursors.WaitCursor;

                // t@Cƃt@C̊gq擾
                dataFileName = dataOpenFileDialog.FileName;
                dataFileExtension = System.IO.Path.GetExtension(dataFileName);

                // gqtxtbin̏ꍇɂ̂ݏs
                if (String.Compare(dataFileExtension, ".txt", true) == 0 || String.Compare(dataFileExtension, ".bin", true) == 0)
                {
                    switch (dataFileExtension.ToLower())
                    {
                        case ".txt":
                            // gqtxt̏ꍇ̏
                            readTextDataFile(dataFileName);
                            break;
                        
                        case ".bin":
                            // gqbin̏ꍇ̏
                            readBinaryDataFile(dataFileName);
                            break;
                    }

                    // Jt@CtH[̃^Cgo[ɒǉ
                    this.Text = mainTitle + " - " + System.IO.Path.GetFileName(dataFileName);

                    // J[}bv\郁\bȟĂяo
                    drawColorMap();
                }
                else
                {
                    MessageBox.Show("t@Č`Ⴂ܂", "t@CG[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }

                // }EX|C^ɖ߂
                Cursor.Current = Cursors.Default;
            }
            else
            {
                MessageBox.Show("ǂݍރt@Cw肵Ă", "t@CG[", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        // eLXg`(CSV)̃t@Cǂݍރ\bh
        private void readTextDataFile(string dataFileName)
        {
            int x, y;                   // JEgp
            string dataRow;             // sf[^̕ۑp
            string[] dataField;         // f[^̕ۑp

            using (System.IO.StreamReader sReader = new System.IO.StreamReader(dataFileName))
            {
                try
                {
                    y = 0;
                    while ((dataRow = sReader.ReadLine())  != null)
                    {
                        dataField = dataRow.Split(',');
                    
                        x = 0;
                        foreach (string d in dataField)
                        {
                            data3D[x, y] = int.Parse(d);
                            x += 1;
                        }
                        y += 1;
                    }
                }
                catch (FormatException)
                {
                    MessageBox.Show("t@C`܂", "t@CG[", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
                catch
                {
                    MessageBox.Show("t@CǍɃG[܂", "t@CG[", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    return;
                }
            }
        }

        // oCi`̃t@Cǂݍރ\bh
        private void readBinaryDataFile(string dataFileName)
        {
            try
            {
                byte[] dataBinary = System.IO.File.ReadAllBytes(dataFileName);
                int c = 0;

                for (int y = 0; y <= 127; y++)
                {
                    for (int x = 0; x <= 127; x++)
                    {
                        // ʂPoCg̃f[^̓ǂݍ
                        // ʂPoCg̃f[^̓ǂݍ
                        // ǂݍ݃f[^̊i[irbNGfBA`j
                        data3D[x, y] = (byte)dataBinary.GetValue(c) * 256 + (byte)dataBinary.GetValue(c + 1);
                        c += 2;
                    }
                }
            }
            catch 
            {
                MessageBox.Show("t@CǍɃG[܂", "t@CG[", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        // J[}bv\郁\bh
        private void drawColorMap()
        {
            // PictureBoxRg[ƓƍBitmapIuWFNg𐶐
            Bitmap bmp = new Bitmap(dataPictureBox.ClientSize.Width, dataPictureBox.ClientSize.Height);

            // PictureBoxRg[ImagevpeBBitmapIuWFNg
            dataPictureBox.Image = bmp;

            // BitmapIuWFNgGraphics쐬
            Graphics gr = Graphics.FromImage(bmp);

            // J[}bv\QdforXe[gg
            for (int y = 0; y <= 127; y++)
            {
                for (int x = 0; x <= 127; x++)
                {
                    // J[}bvւ̊el̕\
                    // 2x2sNZɕ`悷邽߂Line\bh𗘗pB
                    gr.FillRectangle(new SolidBrush(HsvColor(data3D[x, y] / 4095.0, angleStart, angleRange, sharpStart, sharpRange, volStart, volRange)), x * 2, y * 2, 2, 2);
                }
            }

            // dataPictureBox̍XV
            dataPictureBox.Refresh();
        }

        // Nbv{[hփRs[ButtonClickCxgnh
        private void copyToClipboardButton_Click(object sender, EventArgs e)
        {
            // Nbv{[hPictureBox̉摜Rs[
            Clipboard.SetImage(dataPictureBox.Image);
        }

        // F̑т\PictureBoxPaintCxgnh
        private void colorBarPictureBox_Paint(object sender, PaintEventArgs e)
        {
            int ph;   // PictureBoxRg[̏c̃TCY
            int pw;   // PictureBoxRg[̉̃TCY

            ph = colorBarPictureBox.ClientSize.Height;
            pw = colorBarPictureBox.ClientSize.Width;

            // pxAʓxAx̐ݒ͈͂eLXg{bNX擾
            angleStart = int.Parse(angleMinTextBox.Text);
            angleRange = int.Parse(angleMaxTextBox.Text) - int.Parse(angleMinTextBox.Text);
            sharpStart = double.Parse(sharpMinTextBox.Text);
            sharpRange = double.Parse(sharpMaxTextBox.Text) - double.Parse(sharpMinTextBox.Text);
            volStart = double.Parse(volumnMinTextBox.Text);
            volRange = double.Parse(volumnMaxTextBox.Text) - double.Parse(volumnMinTextBox.Text);

            // F̑т̕`
            for (int i = 0; i <= ph; i++)
            {
                e.Graphics.DrawLine(new Pen(HsvColor(1.0 - i / (double)ph, angleStart, angleRange, sharpStart, sharpRange, volStart, volRange)), 0, i, pw, i);
            }
        }

        // F̕ύXBUttonClickCxgnh
        // ł̓J[o[ĕ`悷邽߂̃{^Ƃėp
        private void colorSettingButton_Click(object sender, EventArgs e)
        {
            colorBarPictureBox.Refresh();
            drawColorMap();
        }

        // ƂēnꂽlColor^̒lvZĕԂ\bh
        // value͂OPɋKiꂽlƂ
        // ߂lColor^̒lԂ
        private Color HsvColor(double value, int colorAngleStart, int colorAngleRange, double colorSharpStart, double colorSharpRange, double colorVolStart, double colorVolRange)
        {
            double h;   // px(h)
            double s;   // ʓx(s)
            double v;   // x(v)
            double p1;  // RGBlϊ̍Ɨp
            double p2;  // RGBlϊ̍Ɨp
            double p3;  // RGBlϊ̍Ɨp
            int r = 0;  // Ԃ̊
            int g = 0;  // ΂̊
            int b = 0;  // ̊

            // pxAʓxAx̎Zo
            h = colorAngleStart + colorAngleRange * (1 - value);
            s = colorSharpStart + colorSharpRange * value;
            v = colorVolStart + colorVolRange * value;

            // px̒lORUO̒lɂ
            while (h < 0)
            {
                h += 360;
            }
            h %= 360;

            // ʓx̒lOP̒lɂ
            if (s < 0)
            {
                s = 0;
            }
            if (s > 1)
            {
                s = 1;
            }

            // x̒lOP̒lɂ
            if (v < 0)
            {
                v = 0;
            }
            if (v > 1)
            {
                v = 1;
            }

            // px(h)Aʓx(s)Ax(v)RGBľvZ
            h /= 60;
            p1 = v * (1 - s);
            p2 = v * (1 - s * (h - Math.Floor(h)));
            p3 = v * (1 - s * (1 - (h - Math.Floor(h))));

            // pxƂRGBl̐ݒ
            switch ((int)Math.Floor(h))
            {
                case 0:
                    r = (int)(v * 255);
                    g = (int)(p3 * 255);
                    b = (int)(p1 * 255);
                    break;
                case 1:
                    r = (int)(p2 * 255);
                    g = (int)(v * 255);
                    b = (int)(p1 * 255);
                    break;
                case 2:
                    r = (int)(p1 * 255);
                    g = (int)(v * 255);
                    b = (int)(p3 * 255);
                    break;
                case 3:
                    r = (int)(p1 * 255);
                    g = (int)(p2 * 255);
                    b = (int)(v * 255);
                    break;
                case 4:
                    r = (int)(p3 * 255);
                    g = (int)(p1 * 255);
                    b = (int)(v * 255);
                    break;
                case 5:
                    r = (int)(v * 255);
                    g = (int)(p1 * 255);
                    b = (int)(p2 * 255);
                    break;
            }

            // \bh̖߂l̐ݒ
            return Color.FromArgb(r, g, b);
        }
    }
}