using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

/*****************************************************************

   IVXR[v({eNgjNX TDS2024)g`擾ptH[

*****************************************************************/

namespace TDS2024
{
    public partial class TDS2024Form : Form
    {
        const int xMin = 0;         // g`ʂ̉ŏl
        const int xMax = 2499;      // g`ʂ̉ől
        const int yMin = -128;      // g`ʂ̏cŏl
        const int yMax = 127;       // g`ʂ̏cől

        private DeviceTerminator devTerm;               // uݒpNX^
        private string sendData;                        // Mf[^̕ۑp
        private string recieveData;                     // Mf[^̈ꎞ擾p
        private Point[] dataPoints = new Point[xMax+1]; // g`f[^̕ۑp

        public TDS2024Form()
        {
            InitializeComponent();
        }

        private void TDS2024Form_Load(object sender, EventArgs e)
        {
            // ʐM|[g̏ݒ
            tDS2024SerialPort.PortName = "COM4";                        // ʐM|[gCOM1
            tDS2024SerialPort.BaudRate = 9600;                          // ʐMx9600bps
            tDS2024SerialPort.DataBits = 8;                             // f[^͂Wrbg
            tDS2024SerialPort.Parity = System.IO.Ports.Parity.None;     // peB`FbNȂ
            tDS2024SerialPort.StopBits = System.IO.Ports.StopBits.One;  // Xgbvrbg͂P
            // n[hEFAɂnhVFCN
            tDS2024SerialPort.Handshake = System.IO.Ports.Handshake.RequestToSend;
            tDS2024SerialPort.RtsEnable = true;                         // RTSCLɂ
            tDS2024SerialPort.ReadBufferSize = 8192;                    // obt@TCY

            //@̏ݒ
            // DeviceTerminatorNX̃CX^X𐶐
            devTerm = new DeviceTerminator(DeviceTerminator.DeviceTerminators.LF);
        }

        private void autosetButton_Click(object sender, EventArgs e)
        {
            // ʐM|[gJ
            if (!tDS2024SerialPort.IsOpen)
            {
                tDS2024SerialPort.Open();
            }

            try
            {
                // I[gZbg̑M
                tDS2024SerialPort.WriteLine("AUTOSET EXECUTE");
            }
            catch(Exception ex)
            {
                // MG[̏
                MessageBox.Show(ex.Message, "MG[", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            // ʐM|[g
            tDS2024SerialPort.Close();
        }

        private void waveFormGetButton_Click(object sender, EventArgs e)
        {
            // ʐM|[gJ
            if (!tDS2024SerialPort.IsOpen)
            {
                tDS2024SerialPort.Open();
            }

            try
            {
                // f[^]AXL[`ɐݒ
                sendData = "DATA:ENCDG ASCII";
                tDS2024SerialPort.WriteLine(sendData);
                // f[^]`̖₢킹
                sendData = "DATA:ENCDG?";
                tDS2024SerialPort.WriteLine(sendData);
            }
            catch(Exception ex)
            {
                // MG[̏
                MessageBox.Show(ex.Message, "MG[", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        // t@C-IStripMenuItemClickCxgnh
        private void fileExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // vȌI
            Application.Exit();
        }

        // ݒ-ʐMݒStripMenuItemClickCxgnh
        private void serialPortSettingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // ʐMݒp_CAÕCX^X𐶐
            PropertySettingDialog ps = new PropertySettingDialog();
            // ݒ肷vpeBTDS2024SerialPort̃vpeBw
            ps.settingPropertyGrid.SelectedObject = tDS2024SerialPort;
            // _CAÕ^Cgݒ
            ps.Text = "ʐMݒ";
            // _CAO̕\
            ps.ShowDialog();
            // CX^X̔j
            ps.Dispose();
        }

        // ݒ-uݒStripMenuItemClickCxgnh
        private void terminatorSettingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            // uݒp_CAÕCX^X𐶐
            PropertySettingDialog ps = new PropertySettingDialog();
            // ݒ肷vpeBdevTermw
            ps.settingPropertyGrid.SelectedObject = devTerm;
            // _CAÕ^Cgݒ
            ps.Text = "uݒ";
            // _CAO̕\
            ps.ShowDialog();
            // CX^X̔j
            ps.Dispose();
        }

        // SerialPortRg[DataReceivedCxgnh
        private void tDS2024SerialPort_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            byte[] bBuffer = new byte[8191];    //Mpobt@
            int bc;                             //MoCg

            // Mf[^̎擾
            bc = tDS2024SerialPort.Read(bBuffer, 0, 8191);

            // Mf[^̈ꎞ擾pϐւ̒ǉ
            recieveData += System.Text.Encoding.ASCII.GetString(bBuffer, 0, bc);

            //@Mǂ̔
            if (recieveData.Substring(recieveData.Length - 1) == devTerm.LastString)
            {
                // Mf[^^[~l[^̍폜
                recieveData = recieveData.Substring(0, recieveData.Length - devTerm.Count);

                // Mf[^̏
                switch (sendData)
                {
                    case "DATA:ENCDG?":
                        recieveData = "";
                        // f[^̃\[XCH1ɐݒ
                        sendData = "DATA:SOURCE CH1";
                        tDS2024SerialPort.WriteLine(sendData);
                        // f[^̃\[X̖₢킹
                        sendData = "DATA:SOURCE?";
                        tDS2024SerialPort.WriteLine(sendData);
                        break;

                    case "DATA:SOURCE?":
                        recieveData = "";
                        // f[^̊Jn|CgPɐݒ
                        sendData = "DATA:START 1";
                        tDS2024SerialPort.WriteLine(sendData);
                        // f[^̊Jn|Cg̖₢킹
                        sendData = "DATA:START?";
                        tDS2024SerialPort.WriteLine(sendData);
                        break;

                    case "DATA:START?":
                        recieveData = "";
                        // f[^̏I|Cg2500ɐݒ
                        sendData = "DATA:STOP 2500";
                        tDS2024SerialPort.WriteLine(sendData);
                        // f[^̏I|Cg̖₢킹
                        sendData = "DATA:STOP?";
                        tDS2024SerialPort.WriteLine(sendData);
                        break;

                    case "DATA:STOP?":
                        recieveData = "";
                        // g`vAu̗v𑗐M
                        sendData = "WFMPRE?";
                        tDS2024SerialPort.WriteLine(sendData);
                        break;

                    case "WFMPRE?":
                        // g`vAȕ
                        SetPreamble();

                        recieveData = "";
                        // g`f[^̗v𑗐M
                        sendData = "CURVE?";
                        tDS2024SerialPort.WriteLine(sendData);
                        break;

                    case "CURVE?":
                        // g`f[^̕`
                        DrawData();
                        break;
                }
            }
        }
 
        // g`vAuŃRg[TextvpeBݒ肷邽
        // fQ[g^̐錾
        private delegate void TextChangeDelegate(Label ctrl, string str);
        
        // fQ[g^̃\bh錾
        private void SetText(Label ctrl, string str)
        {
            ctrl.Text = str;
        }

        // g`vAȕ
        private void SetPreamble()
        {
            int i = 1;                  // JEgpϐ
            float xIncriment = 0.0f;    // X̑
            float yMulti = 0.0f;        // Y̑

            // g`vAu̕
            while (recieveData.IndexOf(";") >= 0)
            {
                switch (i)
                {
                    case 1:         // g`1|Cg̃oCg
                        break;
                    case 2:         // g`P|Cg̃rbg
                        break;
                    case 3:         // AXL[f[^oCif[^
                        break;
                    case 4:         // oCif[^̏ꍇ̃tH[}bg
                        break;
                    case 5:         // QoCgf[^̏ꍇ̓]
                        break;
                    case 6:         // f[^̃|Cg
                        break;
                    case 7:         // ͌⃌WȂǔg`Ɋւ
                        break;
                    case 8:         // g`f[^̃tH[}bg
                        break;
                    case 9:         // X̑
                        xIncriment = float.Parse(recieveData.Substring(recieveData.IndexOf(" ") + 1, recieveData.IndexOf(";") - recieveData.IndexOf(" ") - 1));
                        break;
                    case 10:        // g`gK̃|Cgʒu
                        break;
                    case 11:        // X̃[
                        break;
                    case 12:        // X̒P
                        break;
                    case 13:        // Y̑
                        yMulti = float.Parse(recieveData.Substring(recieveData.IndexOf(" ") + 1, recieveData.IndexOf(";") - recieveData.IndexOf(" ") - 1));
                        break;
                    case 14:        // Ỹ[
                        break;
                    case 15:        // ỸItZbg
                        break;
                    case 16:        // Y̒P
                        break;
                }

                // ̔g`vAuf[^擾
                recieveData = recieveData.Substring(recieveData.IndexOf(";") + 1);
                i += 1;
            }

            // fQ[g^̕ϐ̐錾Ɛ
            TextChangeDelegate setT = new TextChangeDelegate(SetText);

            // LabelRg[TextvpeBݒ
            Invoke(setT, new Object[] {verticalUnitLabel, "ctXP[ : " + (yMulti * 256).ToString("0.0E0") + " V"});
            Invoke(setT, new Object[] {horizontalUnitLabel, "tXP[ : " + (xIncriment * (xMax + 1)).ToString("0.0E0") + " s"});

        }

        // g`f[^`PictureBoxRg[Refresh\bhݒ肷邽
        // fQ[g^̐錾
        private delegate void WaveFormPictureBoxRefreshDelegate();

        // fQ[g^̃\bh錾
        private void WaveFormPictureBoxRefresh()
        {
            waveFormPictureBox.Refresh();
        }

        // g`f[^̕`
        private void DrawData()
        {
            int i = 0;      //@JEgpϐ

            // Mf[^ŏ̃f[^ȊO̕폜
            recieveData = recieveData.Substring(recieveData.IndexOf(" ") + 1);

            // g`f[^̕
            while (recieveData.IndexOf(",") >= 0)
            {
                // g`f[^̊e`l̕ۑ
                dataPoints[i] = new Point(i, int.Parse(recieveData.Substring(0, recieveData.IndexOf(","))));

                // ̔g`f[^擾
                recieveData = recieveData.Substring(recieveData.IndexOf(",") + 1);
                i += 1;
            }

            // ŏI`l̔g`f[^̕ۑ
            dataPoints[i] = new Point(i, int.Parse(recieveData));

            // fQ[g^̕ϐ̐錾Ɛ
            WaveFormPictureBoxRefreshDelegate picref = new WaveFormPictureBoxRefreshDelegate(WaveFormPictureBoxRefresh);

            // PictureBoxRg[Refresh\bȟďo
            Invoke(picref);
        }

        private void waveFormPictureBox_Paint(object sender, PaintEventArgs e)
        {
            // Wϊp̃TCY擾
            float x = waveFormPictureBox.ClientSize.Width / (float)(xMax - xMin);
            float y = waveFormPictureBox.ClientSize.Height / (float)(yMin - yMax);

            // W̕ϊ
            e.Graphics.TranslateTransform(xMin, -yMax);
            e.Graphics.ScaleTransform(x, y, System.Drawing.Drawing2D.MatrixOrder.Append);

            // `̈̃NA
            e.Graphics.Clear(waveFormPictureBox.BackColor);

            // S`悷Pen̐ݒ
            Pen p = new Pen(Color.Black);
            p.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;

            // `̈̒S̕`
            e.Graphics.DrawLine(p, xMin, (yMax + yMin) / 2, xMax, (yMax + yMin) / 2);
            e.Graphics.DrawLine(p, (xMax + xMin) / 2, yMax, (xMax + xMin) / 2, yMin);

            // g`̕`
            e.Graphics.DrawLines(Pens.Black, dataPoints);
        }
    }
}