using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
//using NationalInstruments.NI4882;   // GP-IBvO~OEC^tF[X
using GPIBDummyDriver;

//*********************************************************
//
//   Iwatsu VOAC7412 tgpl tH[
//
//*********************************************************

namespace VOAC7412Front
{
    public partial class VOAC7412FrontForm : Form
    {
        Device device;      // GP-IB@CX^Xϐ
        bool power;         // }`[^̓dON/OFF
        int range;          // ݂̑背W

        public VOAC7412FrontForm()
        {
            InitializeComponent();
        }

        // tH[LoadCxgnh
        private void VOAC7412FrontForm_Load(object sender, EventArgs e)
        {
            // ϐ̏ݒ
            power = false;
            range = 1;

            // tH[̕\̏ݒ
            dataLabel.Text = "OFF";
            unitLabel.Text = "";

            // GP-IBAhXINumericUpDownRg[̐ݒ
            gPIBAddressNumericUpDown.Value = 1;

            // t@NVIComboBoxRg[̐ݒ
            functionComboBox.Items.AddRange(new string[] {"DCV", "ACV", "", "DCA", "ACA", "", "Hz", "LO-"});
            functionComboBox.SelectedIndex = 0;
        }
        
        // tH[FormClosingCxgnh
        private void VOAC7412FrontForm_FormClosing(object sender, FormClosingEventArgs e)
        {

            // IWATSU VOAC7412̐R}h̑o
            device.Write("PA0");        // AVG OFF

            // GP-IB@[Jɐݒ
            device.GoToLocal();

            // GP-IB@̔j
            device.Dispose();
        }
 
        // dON/OFFݒ肷LabelRg[ClickCxgnh
        // ł̓dON/OFFƂ̓}`[^̃[g/[JԂ\
        private void powerSwitchLabel_Click(object sender, EventArgs e)
        {
            byte addr;          // }`[^GP-IBAhX

            // ON̐ݒ
            if (!power)
            {
                // GP-IB@AhX̐ݒl̎擾
                addr = (byte)gPIBAddressNumericUpDown.Value;

                // GP-IB@̏
                try
                {
                    // GP-IB@̃CX^X̐
                    device = new Device(0, addr);
                   
                    // foCX̃NA
                    device.Clear();
                }
                catch (Exception)
                {
                    MessageBox.Show("GP-IB̏ɃG[܂", "GP-IBG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    return;
                }

                // IWATSU VOAC7412̐R}h̑o
                try
                {
                    device.Write("X2 AE0 AA5 PA1");      
                }
                catch (Exception)
                {
                    MessageBox.Show("MɃG[܂", "MG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    device.GoToLocal();
                    return;
                }

                // d{^̕\̐ݒ
                powerSwitchLabel.BackColor = Color.Red;

                // d̏Ԃ͂ϐ̐ݒ
                power = true;

                // OFF̐ݒ
            }
            else
            {
                // GP-IB@[Jɐݒ
                try
                {
                    device.GoToLocal();
                }
                catch (Exception)
                {
                    MessageBox.Show("ؒfɃG[܂", "ؒfG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    return;
                }

                // tH[̕\̐ݒ
                dataLabel.Text = "OFF";
                unitLabel.Text = "";

                // d{^̕\̐ݒ
                powerSwitchLabel.BackColor = Color.White;

                // d̏Ԃ͂ϐ̐ݒ
                power = false;
            }
        }
        
        // t@NVݒ肷ComboBoxRg[
        // SelectedIndexChangedCxgnh
        private void functionComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            string cmd = "";

            // t@NV̕ύX
            // dI̎̂ݏs
            if (power)
            {
                // t@NV؂ւR}h̐ݒ
                switch (functionComboBox.SelectedIndex)
                {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                        cmd = "F" + functionComboBox.SelectedIndex.ToString();
                        break;
                    case 6:
                        cmd = "F7";
                        break;
                    case 7:
                        cmd = "F10";
                        break;
                }

                // IWATSU VOAC7412̐R}h̑o
                try
                {
                    device.Write(cmd);      
                }
                catch (Exception)
                {
                    MessageBox.Show("MɃG[܂", "MG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    return;
                }
            
            }
        }
        

        // 背Wݒ肷RButtonRg[ClickCxgnh
        private void rangeButton_Click(object sender, EventArgs e)
        {
            int ran;        // 背W

            // 背W̕ύX
            // dI̎̂ݏs
            if (power)
            {
                // I[gW\̐ݒ
                if (((Button)sender).Name == rangeAutoButton.Name)
                {
                    rangeAutoLabel.BackColor = Color.Red;
                }
                else
                {
                    rangeAutoLabel.BackColor = Color.White;
                }

                // 背W؂ւR}h̐ݒ
                if (((Button)sender).Name == rangeDownButton.Name)
                {
                    range -= 1;
                    if (range == 0)
                    { 
                        range = 8;
                    }
                    ran = range;
                }
                else if (((Button)sender).Name == rangeUpButton.Name)
                { 
                    range += 1;
                    if (range == 9)
                    {
                        range = 1;
                    }
                    ran = range;
                }
                else	// I[gW{^̑I
                {        
                    ran = 0;
                }

                // IWATSU VOAC7412̐R}h̑o
                try
                {
                    device.Write("R" + ran);      
                }
                catch (Exception)
                {
                    MessageBox.Show("MɃG[܂", "MG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    device.GoToLocal();
                    return;
                }
            }
        }
 

        //@TimerRg[TickCxgnh
        private void measureTimer_Tick(object sender, EventArgs e)
        {
            byte sPoll;             // |[Op
            string buffer = "";

            // dI̎̂ݏs
            if (power)
            {
                // |[Oɂ@킩̑IM̌o
                do
                {
                    sPoll = (byte)device.SerialPoll();
                } while ((sPoll & 16) == 16);

                // GP-IB@킩̒l̓ǂݍ
                try
                {
                    buffer = device.ReadString();
                }
                catch (Exception)
                {
                    MessageBox.Show("MɃG[܂", "MG[", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    return;
                }

                // l̕\
                dataLabel.Text = buffer.Substring(4);

                // l̒Pʂ̕\
                switch (buffer.Substring(0, 2))
                {
                    case "DV":
                    case "AV":
                        unitLabel.Text = "V";
                        break;
                    case "R ":
                        unitLabel.Text = "";
                        break;
                    case "DA":
                    case "AA":
                        unitLabel.Text = "A";
                        break;
                    case "TC":
                        unitLabel.Text = "C";
                        break;
                    case "F ":
                        unitLabel.Text = "Hz";
                        break;
                }
            }
        }
    }
}