using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;     //ǉ
using TekScope_TektronixLib;        //ǉ

/****************************************************************
    
   IVXR[v({eNgjNX DPO4104)g`擾ptH[
    
****************************************************************/


namespace DPO4104
{
    public partial class DPO4104Form : Form
    {
        // \[X
        const string source = "USB0::1689::1025::xxxxxxx::0::INSTR";

        private int xMin = 0;       // g`ʂ̉ŏl
        private int xMax = 999;     // g`ʂ̉őlCf[^_
        private double yMin = 1;    // g`ʂ̏cŏl
        private double yMax = -1;   // g`ʂ̏cől

        private PointF[] dataPoints =new PointF[2];      //@g`f[^̕ۑp

        public DPO4104Form()
        {
            InitializeComponent();
        }

        private void DPO4104Form_Load(object sender, EventArgs e)
        {
            this.Text += "(" + source + ")";
            this.SetStyle(ControlStyles.ResizeRedraw, true);
        }

        private void autosetButton_Click(object sender, EventArgs e)
        {
            TekScope myScope = new TekScope();
            myScope.Initialize(source, false, false, "");
            myScope.Acquisition.AutoSet();
            myScope.Close();
        }

        private void waveFormGetButton_Click(object sender, EventArgs e)
        {
            TekScope myScope = new TekScope();

            // 
            myScope.Initialize(source, false, false, "");

            // ̎擾
            double hPos = 0;
            double hScale = 0;
            int hRecLen = 0;
            myScope.Horizontal.Read(ref hPos, ref hScale, ref hRecLen);

            xMax = hRecLen -1;
            dataPoints = new PointF[xMax+1];

            horizontalUnitLabel.Text = "tXP[ : " + (hScale * 10).ToString("0.00E0") + " s ; " + "R[h : " + hRecLen.ToString("0,000");

            // c̎擾
            string ChName = myScope.Channels.get_Name(1);
            double vPos = 0;
            double vScale = 0;
            double vOffset = 0;
            double vDeskew = 0;
            TekScopeChannelCouplingEnum vCoupling = TekScopeChannelCouplingEnum.TekScopeChannelCouplingDC; 
            TekScopeChannelTerminationEnum vTermination = TekScopeChannelTerminationEnum.TekScopeChannelTermination1MEG;
            double vBandwidth = 0;
            bool vDisplayState = false;
            myScope.Channels.get_Item(ChName).Read(ref vPos, ref vScale, ref vOffset, ref vDeskew, ref vCoupling, ref vTermination, ref vBandwidth, ref vDisplayState);

            yMin = vOffset - vScale * 5;
            yMax = vOffset + vScale * 5;

            verticalUnitLabel.Text = "ctXP[ : " + (yMax - yMin).ToString("0.00E0") + " V";

            // g`̎擾
            double initialX = 0;
            double xIncrement = 0;
            Array wfmOut = null;
            myScope.WaveformTransfer.ReadWaveform(TekScopeSourceEnum.TekScopeSourceCh1, 60000, ref wfmOut, ref initialX, ref xIncrement);

            int i = 0;
            foreach (double wf in wfmOut)
            {
                dataPoints[i] = new PointF(i, (float)wf);
                i += 1;
            }

            // 
            myScope.Close();

            waveFormPictureBox.Refresh();
        }

        // g`f[^`
        private void waveFormPictureBox_Paint(object sender, PaintEventArgs e)
        {
            // Wϊp̃TCY擾
            double x = (double)waveFormPictureBox.ClientSize.Width / (double)(xMax - xMin);
            double y = waveFormPictureBox.ClientSize.Height / (yMin - yMax);

            // W̕ϊ
            e.Graphics.TranslateTransform((float)xMin, (float)(-yMax));
            e.Graphics.ScaleTransform((float)x, (float)y, MatrixOrder.Append);

            // `̈̃NA
            e.Graphics.Clear(waveFormPictureBox.BackColor);

            // `̈̎ݒ
            e.Graphics.DrawLine(Pens.Black, xMin, (float)((yMax + yMin) / 2), xMax, (float)((yMax + yMin) / 2));
            e.Graphics.DrawLine(Pens.Black, (xMax + xMin) / 2, (float)yMax, (xMax + xMin) / 2, (float)yMin);
            // g`̕`
            e.Graphics.DrawLines(Pens.Red, dataPoints);
        }
    }
}